import { __decorate, __extends, __param, __spread } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Inject, forwardRef, HostListener, Directive, Input, Component, ViewChild, NgModule } from '@angular/core';
import { NgAisInstantSearch, BaseWidget, NgAisModule } from 'angular-instantsearch';
import { connectToggleRefinement, connectMenu, connectPagination } from 'instantsearch.js/es/connectors';
import { MatSelectModule } from '@angular/material/select';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatPaginatorModule } from '@angular/material/paginator';
import { CommonModule } from '@angular/common';

var AlgoliaService = /** @class */ (function () {
    function AlgoliaService() {
    }
    AlgoliaService.ɵprov = ɵɵdefineInjectable({ factory: function AlgoliaService_Factory() { return new AlgoliaService(); }, token: AlgoliaService, providedIn: "root" });
    AlgoliaService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], AlgoliaService);
    return AlgoliaService;
}());

var connectRefresh = function (renderFn, unmountFn) { return function (widgetParams) {
    if (widgetParams === void 0) { widgetParams = {}; }
    return ({
        init: function () {
            renderFn({
                refresh: function () {
                }
            }, true);
        },
        render: function (_a) {
            var instantSearchInstance = _a.instantSearchInstance;
            var refresh = instantSearchInstance.refresh.bind(instantSearchInstance);
            renderFn({ refresh: refresh }, false);
        },
        dispose: function () {
            unmountFn();
        }
    });
}; };
var ɵ0 = connectRefresh;
var MatAlgoliaRefreshDirective = /** @class */ (function (_super) {
    __extends(MatAlgoliaRefreshDirective, _super);
    function MatAlgoliaRefreshDirective(instantSearchParent) {
        var _this = _super.call(this, 'Refresh') || this;
        _this.instantSearchParent = instantSearchParent;
        return _this;
    }
    MatAlgoliaRefreshDirective.prototype.ngOnInit = function () {
        this.createWidget(connectRefresh, {});
        _super.prototype.ngOnInit.call(this);
    };
    MatAlgoliaRefreshDirective.prototype.onClick = function () {
        console.log('click');
        this.state.refresh();
    };
    MatAlgoliaRefreshDirective.ctorParameters = function () { return [
        { type: NgAisInstantSearch, decorators: [{ type: Inject, args: [forwardRef(function () { return NgAisInstantSearch; }),] }] }
    ]; };
    __decorate([
        HostListener('click')
    ], MatAlgoliaRefreshDirective.prototype, "onClick", null);
    MatAlgoliaRefreshDirective = __decorate([
        Directive({
            selector: '[matAlgoliaRefresh]'
        }),
        __param(0, Inject(forwardRef(function () { return NgAisInstantSearch; })))
    ], MatAlgoliaRefreshDirective);
    return MatAlgoliaRefreshDirective;
}(BaseWidget));

var MatAlgoliaToggleComponent = /** @class */ (function (_super) {
    __extends(MatAlgoliaToggleComponent, _super);
    function MatAlgoliaToggleComponent(instantSearchParent) {
        var _this = _super.call(this, 'MatAlgoliaToggleComponent') || this;
        _this.instantSearchParent = instantSearchParent;
        return _this;
    }
    MatAlgoliaToggleComponent.prototype.ngOnInit = function () {
        this.createWidget(connectToggleRefinement, {
            // instance options
            attribute: this.attribute
        });
        _super.prototype.ngOnInit.call(this);
    };
    MatAlgoliaToggleComponent.prototype.onChange = function ($event) {
        console.log('onChange', $event);
        this.state.refine(this.state.value);
        // this.state.refine($event.checked);
    };
    MatAlgoliaToggleComponent.ctorParameters = function () { return [
        { type: NgAisInstantSearch, decorators: [{ type: Inject, args: [forwardRef(function () { return NgAisInstantSearch; }),] }] }
    ]; };
    __decorate([
        Input()
    ], MatAlgoliaToggleComponent.prototype, "attribute", void 0);
    __decorate([
        Input()
    ], MatAlgoliaToggleComponent.prototype, "label", void 0);
    __decorate([
        Input()
    ], MatAlgoliaToggleComponent.prototype, "color", void 0);
    MatAlgoliaToggleComponent = __decorate([
        Component({
            selector: 'mat-algolia-toggle',
            template: "<mat-slide-toggle (change)=\"onChange($event)\"\n                  *ngIf=\"state?.value\"\n                  [checked]=\"state?.value?.isRefined\">\n  {{ label || state?.value?.name}}\n  <span *ngIf=\"!state?.value?.isRefined\">({{state?.value?.count}})</span>\n</mat-slide-toggle>\n",
            styles: [""]
        }),
        __param(0, Inject(forwardRef(function () { return NgAisInstantSearch; })))
    ], MatAlgoliaToggleComponent);
    return MatAlgoliaToggleComponent;
}(BaseWidget));

var MatAlgoliaMenuSelectComponent = /** @class */ (function (_super) {
    __extends(MatAlgoliaMenuSelectComponent, _super);
    function MatAlgoliaMenuSelectComponent(instantSearchParent) {
        var _this = _super.call(this, 'MatAlgoliaMenuSelectComponent') || this;
        _this.instantSearchParent = instantSearchParent;
        return _this;
    }
    MatAlgoliaMenuSelectComponent.prototype.ngOnInit = function () {
        this.createWidget(connectMenu, { attribute: this.attribute });
        _super.prototype.ngOnInit.call(this);
    };
    MatAlgoliaMenuSelectComponent.ctorParameters = function () { return [
        { type: NgAisInstantSearch, decorators: [{ type: Inject, args: [forwardRef(function () { return NgAisInstantSearch; }),] }] }
    ]; };
    __decorate([
        Input()
    ], MatAlgoliaMenuSelectComponent.prototype, "attribute", void 0);
    MatAlgoliaMenuSelectComponent = __decorate([
        Component({
            selector: 'mat-algolia-menu-select',
            template: "<select\n  (change)=\"state.refine($event.target.value)\"\n  class=\"menu-select\"\n>\n  <option\n    *ngFor=\"let item of state.items\"\n    [selected]=\"item.isRefined\"\n    [value]=\"item.value\"\n  >\n    {{item.label}}\n  </option>\n</select>\n",
            styles: [""]
        }),
        __param(0, Inject(forwardRef(function () { return NgAisInstantSearch; })))
    ], MatAlgoliaMenuSelectComponent);
    return MatAlgoliaMenuSelectComponent;
}(BaseWidget));

var MatAlgoliaPaginationComponent = /** @class */ (function (_super) {
    __extends(MatAlgoliaPaginationComponent, _super);
    function MatAlgoliaPaginationComponent(instantSearchParent) {
        var _this = _super.call(this, 'MatAlgoliaPaginationComponent') || this;
        _this.instantSearchParent = instantSearchParent;
        _this.items = [
            { label: '1 hits per page', value: 10, default: true },
            { label: '2 hits per page', value: 15 },
            { label: '2 hits per page', value: 25 },
            { label: '2 hits per page', value: 50 }
        ];
        return _this;
    }
    MatAlgoliaPaginationComponent.prototype.ngOnInit = function () {
        this.createWidget(connectPagination, {
        // instance options
        });
        _super.prototype.ngOnInit.call(this);
    };
    MatAlgoliaPaginationComponent.prototype.onPageChanged = function (pageEvent, hpp) {
        console.log('onPageChanged', pageEvent, this.pageSize, pageEvent.pageSize);
        if (this.pageSize !== pageEvent.pageSize) {
            console.log('refining', this.pageSize, pageEvent.pageSize);
            this.pageSize = pageEvent.pageSize;
            hpp.state.refine(this.pageSize);
        }
        if (pageEvent.pageIndex !== pageEvent.previousPageIndex) {
            this.state.refine(this.state.currentRefinement + (pageEvent.pageIndex > pageEvent.previousPageIndex ? 1 : -1));
        }
    };
    MatAlgoliaPaginationComponent.prototype.getDefaultPageSize = function (hpp) {
        // this.pageSize = hpp.state.items.filter(item => item.default === true).map(item => item.value)[0];
        // return this.pageSize;
        return hpp.state.items.filter(function (item) { return item.default === true; }).map(function (item) { return item.value; })[0];
    };
    MatAlgoliaPaginationComponent.prototype.getPageSizeOptions = function (hpp) {
        if (hpp && hpp.state.items) {
            // console.log('page size options', hpp.state.items.map(item => item.value));
            return hpp.state.items.map(function (item) { return item.value; });
        }
        else {
            return 0;
        }
    };
    MatAlgoliaPaginationComponent.ctorParameters = function () { return [
        { type: NgAisInstantSearch, decorators: [{ type: Inject, args: [forwardRef(function () { return NgAisInstantSearch; }),] }] }
    ]; };
    __decorate([
        ViewChild('hpp')
    ], MatAlgoliaPaginationComponent.prototype, "hitsPerPage", void 0);
    MatAlgoliaPaginationComponent = __decorate([
        Component({
            selector: 'mat-algolia-pagination',
            template: "<ais-hits-per-page #hpp [items]=\"items\"\n                   style=\"display: none\"\n></ais-hits-per-page>\n<mat-paginator (page)=\"onPageChanged($event,hpp)\"\n               [length]=\"state.nbHits\"\n               [pageSizeOptions]=\"getPageSizeOptions(hpp)\"\n               [pageSize]=\"getDefaultPageSize(hpp)\">\n</mat-paginator>\n",
            styles: [""]
        }),
        __param(0, Inject(forwardRef(function () { return NgAisInstantSearch; })))
    ], MatAlgoliaPaginationComponent);
    return MatAlgoliaPaginationComponent;
}(BaseWidget));

var components = [
    MatAlgoliaRefreshDirective,
    MatAlgoliaToggleComponent,
    MatAlgoliaMenuSelectComponent,
    MatAlgoliaPaginationComponent
];
var directives = [MatAlgoliaRefreshDirective];
var MatAlgoliaModule = /** @class */ (function () {
    function MatAlgoliaModule() {
    }
    MatAlgoliaModule = __decorate([
        NgModule({
            declarations: __spread(components, directives),
            imports: [
                // Angular
                CommonModule,
                // Angular Material
                MatSelectModule,
                MatSlideToggleModule,
                MatPaginatorModule,
                // Algolia
                NgAisModule
            ],
            exports: __spread(components, directives)
        })
    ], MatAlgoliaModule);
    return MatAlgoliaModule;
}());

/*
 * Public API Surface of algolia
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AlgoliaService, MatAlgoliaMenuSelectComponent, MatAlgoliaModule, MatAlgoliaPaginationComponent, MatAlgoliaRefreshDirective, MatAlgoliaToggleComponent, ɵ0, MatAlgoliaRefreshDirective as ɵa, MatAlgoliaToggleComponent as ɵb, MatAlgoliaMenuSelectComponent as ɵc, MatAlgoliaPaginationComponent as ɵd };
//# sourceMappingURL=angular-material-extensions-algolia.js.map
